/* eslint no-unused-vars:0 */

'use strict';

import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _Map from 'babel-runtime/core-js/map';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _extends from 'babel-runtime/helpers/extends';
import _getIterator from 'babel-runtime/core-js/get-iterator';
import _slicedToArray from 'babel-runtime/helpers/slicedToArray';
import _Number$isNaN from 'babel-runtime/core-js/number/is-nan';
import _WeakMap from 'babel-runtime/core-js/weak-map';
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import now from 'performance-now';
import Easing from 'easing-js';
import raf from 'raf';
import _ from 'lodash';

var privates = new _WeakMap();

export var isNumber = function isNumber(obj) {
    return typeof obj === 'number' && !_Number$isNaN(obj);
};

export var strip = function strip(number) {
    return parseFloat(number.toPrecision(12));
};

export var isAnimating = function isAnimating(animations) {
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = _getIterator(animations), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var _ref = _step.value;

            var _ref2 = _slicedToArray(_ref, 2);

            var animation = _ref2[1];

            if (animation.isAnimating) return true;
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }

    return false;
};

var scheduleAnimation = function scheduleAnimation(context) {
    raf(function () {
        var animations = privates.get(context);
        var currentTime = now();
        var shouldUpdate = false;
        animations && animations.forEach(function (animation, name) {
            var isFunction = typeof name === 'function';
            if (!animation.isAnimating) return;
            var duration = animation.duration,
                easing = animation.easing,
                endValue = animation.endValue,
                startTime = animation.startTime,
                startValue = animation.startValue;

            var deltaTime = currentTime - startTime;
            if (deltaTime >= duration) {
                _extends(animation, { isAnimating: false, startTime: currentTime, value: endValue });
            } else {
                animation.value = strip(Easing[easing](deltaTime, startValue, endValue - startValue, duration));
            }
            shouldUpdate = shouldUpdate || !isFunction;
            if (isFunction) name(animation.value);
        });
        if (animations && isAnimating(animations)) scheduleAnimation(context);
        if (shouldUpdate) context.forceUpdate();
    });
};

var Back2Top = function (_Component) {
    _inherits(Back2Top, _Component);

    function Back2Top(props) {
        _classCallCheck(this, Back2Top);

        var _this = _possibleConstructorReturn(this, (Back2Top.__proto__ || _Object$getPrototypeOf(Back2Top)).call(this, props));

        _this.animate = _this.animate.bind(_this);
        _this.scrollToTop = _this.scrollToTop.bind(_this);
        _this.updateScroll = _this.updateScroll.bind(_this);
        _this.shouldAnimate = _this.shouldAnimate.bind(_this);
        _this.animate = _this.animate.bind(_this);
        _this.scrollToTop = _this.scrollToTop.bind(_this);
        _this.getScrollTop = _this.getScrollTop.bind(_this);
        _this.setScrollTop = _this.setScrollTop.bind(_this);

        _this.state = {
            visible: false
        };
        return _this;
    }

    _createClass(Back2Top, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.throttledUpdateScroll = _.throttle(this.updateScroll, 100);
            window.addEventListener('scroll', this.throttledUpdateScroll);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            privates.delete(this);
            window.removeEventListener('scroll', this.throttledUpdateScroll);
        }
    }, {
        key: 'shouldAnimate',
        value: function shouldAnimate() {
            return true;
        }
    }, {
        key: 'animate',
        value: function animate(name, endValue, duration) {
            var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

            var animations = privates.get(this);
            if (!animations) {
                privates.set(this, animations = new _Map());
            }
            var animation = animations.get(name);
            var shouldAnimate = this.shouldAnimate() && options.animation !== false;
            if (!animation || !shouldAnimate || !isNumber(endValue)) {
                var easing = options.easing || 'linear';
                var startValue = isNumber(options.startValue) && shouldAnimate ? options.startValue : endValue;
                animation = { duration: duration, easing: easing, endValue: endValue, isAnimating: false, startValue: startValue, value: startValue };
                animations.set(name, animation);
            }
            if (!duration) {
                _extends(animation, { endValue: endValue, value: endValue });
                animations.set(name, animation);
            }
            if (animation.value !== endValue && !animation.isAnimating) {
                if (!isAnimating(animations)) scheduleAnimation(this);
                var startTime = 'startTime' in options ? options.startTime : now();
                duration = duration || animation.duration;
                var _easing = options.easing || animation.easing;
                var _startValue = animation.value;
                _extends(animation, { isAnimating: true, endValue: endValue, startValue: _startValue, startTime: startTime, duration: duration, easing: _easing });
            }
            return animation.value;
        }
    }, {
        key: 'updateScroll',
        value: function updateScroll() {
            var visibilityHeight = this.props.visibilityHeight;

            this.setState({ visible: this.getScrollTop() > (visibilityHeight || Back2Top.VISIBILITY_HEIGHT) });
        }
    }, {
        key: 'scrollToTop',
        value: function scrollToTop(e) {
            var _this2 = this;

            if (e) e.preventDefault();
            var _props = this.props,
                scrollDuration = _props.scrollDuration,
                onClick = _props.onClick;

            this.animate(function (value) {
                return _this2.setScrollTop(value);
            }, 0, scrollDuration || Back2Top.SCROLL_DURATION, { startValue: this.getScrollTop() });
            if (onClick) {
                onClick(e);
            }
        }
    }, {
        key: 'getScrollTop',
        value: function getScrollTop() {
            return document.documentElement.scrollTop;
        }
    }, {
        key: 'setScrollTop',
        value: function setScrollTop(value) {
            document.body.scrollTop = value;
            document.documentElement.scrollTop = value;
        }
    }, {
        key: 'render',
        value: function render() {
            var visible = this.props.alwaysVisible || this.state.visible;

            var _props2 = this.props,
                href = _props2.href,
                style = _props2.style,
                target = _props2.target,
                onClick = _props2.onClick,
                className = _props2.className,
                fadeDuration = _props2.fadeDuration,
                visibilityHeight = _props2.visibilityHeight,
                scrollDuration = _props2.scrollDuration,
                children = _props2.children,
                options = _objectWithoutProperties(_props2, ['href', 'style', 'target', 'onClick', 'className', 'fadeDuration', 'visibilityHeight', 'scrollDuration', 'children']);

            var opacity = this.animate('opacity', visible ? 1 : 0, fadeDuration || Back2Top.FADE_DURATION);
            if (opacity === 0) return false;
            return React.createElement(
                'a',
                _extends({
                    className: className || 'back-to-top'
                }, options, {
                    'aria-label': 'Back2Top',
                    style: { display: 'inline', opacity: opacity },
                    onClick: this.scrollToTop }),
                children
            );
        }
    }]);

    return Back2Top;
}(Component);

Back2Top.propTypes = {

    // Make the button visible
    alwaysVisible: PropTypes.bool,

    // Duration of fade effect
    fadeDuration: PropTypes.number,

    // Duration of scroll-to-top effect
    scrollDuration: PropTypes.number,

    // Height of button to become visible
    visibilityHeight: PropTypes.number

};
Back2Top.FADE_DURATION = 300;
Back2Top.SCROLL_DURATION = 800;
Back2Top.VISIBILITY_HEIGHT = 400;


Back2Top.prototype.displayName = 'Back2Top';

export default Back2Top;